我是靠谱客的博主 含蓄冷风,最近开发中收集的这篇文章主要介绍codeforces 508B,觉得挺不错的,现在分享给大家,希望可以做个参考。

概述

B. Anton and currency you all know
time limit per test0.5 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Berland, 2016. The exchange rate of currency you all know against the burle has increased so much that to simplify the calculations, its fractional part was neglected and the exchange rate is now assumed to be an integer.

Reliable sources have informed the financier Anton of some information about the exchange rate of currency you all know against the burle for tomorrow. Now Anton knows that tomorrow the exchange rate will be an even number, which can be obtained from the present rate by swapping exactly two distinct digits in it. Of all the possible values that meet these conditions, the exchange rate for tomorrow will be the maximum possible. It is guaranteed that today the exchange rate is an odd positive integer n. Help Anton to determine the exchange rate of currency you all know for tomorrow!

Input
The first line contains an odd positive integer n — the exchange rate of currency you all know for today. The length of number n’s representation is within range from 2 to 105, inclusive. The representation of n doesn’t contain any leading zeroes.

Output
If the information about tomorrow’s exchange rate is inconsistent, that is, there is no integer that meets the condition, print  - 1.

Otherwise, print the exchange rate of currency you all know against the burle for tomorrow. This should be the maximum possible number of those that are even and that are obtained from today’s exchange rate by swapping exactly two digits. Exchange rate representation should not contain leading zeroes.

Examples
input
527
output
572
input
4573
output
3574
input
1357997531
output
-1
题目大意:给一个奇数,只交换其中两个,得到一个最大的偶数,若不存在输出-1


思路:
既然给的是一个奇数,那么要让它变成一个偶数的话必然是让最后一位变成一个偶数
要最大的偶数,显然是个贪心
贪心思想如下

从第一位到末尾找,找第一个小于末尾奇数的偶数,交换,此时这个数变大的最多(因为数位高)
如果找不到小于末尾奇数的偶数,那么从倒数第二位开始向第一位找,找第一个偶数,交换,此时这个数变小的最少(因为数位低)
如果两遍都找不到,那么是不存在构成偶数的情况,输出-1
复杂度应该是O(n)

代码

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
int main()
{
    bool f=1;
    string a;
    cin>>a;char t=a[a.length()-1];
    for(int i=0;f&&a[i];++i)
    if(a[i]<t&&!((a[i]-'0')&1))
    {
        f=0;
        swap(a[i],a[a.length()-1]);
    }
    if(f)
    for(int i=a.length()-2;f&&i>=0;--i)
    if(!((a[i]-'0')&1))
    {
        f=0;
        swap(a[i],a[a.length()-1]);
    }
    if(f)
    cout<<"-1";
    else
    cout<<a;
    return 0;
}

//我AC的第一道CF上的题orz

最后

以上就是含蓄冷风为你收集整理的codeforces 508B的全部内容,希望文章能够帮你解决codeforces 508B所遇到的程序开发问题。

如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。

本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
点赞(62)

评论列表共有 0 条评论

立即
投稿
返回
顶部